from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Cd_Hit_Dup_V0_1_0 = CommandToolBuilder(tool="cd_hit_dup", base_command=["cd-hit-dup"], inputs=[ToolInput(tag="in_input_file_fastq", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="Input file (FASTQ or FASTA);")), ToolInput(tag="in_i_two", input_type=Boolean(optional=True), prefix="-i2", doc=InputDocumentation(doc="Second input file (FASTQ or FASTA);")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Output file;")), ToolInput(tag="in_o_two", input_type=File(optional=True), prefix="-o2", doc=InputDocumentation(doc="Output file for R2;")), ToolInput(tag="in_description_length_default", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc="Description length (default 0, truncate at the first whitespace character)")), ToolInput(tag="in_length_prefix_used", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="Length of prefix to be used in the analysis (default 0, for full/maximum length);")), ToolInput(tag="in_match_length_truefalse", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="Match length (true/false, default true);")), ToolInput(tag="in_maximum_number_allowd", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="Maximum number of mismatches allowd;")), ToolInput(tag="in_filter_chimeric_clusters", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Filter out chimeric clusters (true/false, default false);")), ToolInput(tag="in_minimum_length_common", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="Minimum length of common sequence shared between a chimeric read\nand each of its parents (default 30, minimum 20);")), ToolInput(tag="in_abundance_cutoff_default", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="Abundance cutoff (default 1 without chimeric filtering, 2 with chimeric filtering);")), ToolInput(tag="in_abundance_ratio_parent", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="Abundance ratio between a parent read and chimeric read (default 1);")), ToolInput(tag="in_dissimilarity_control_chimeric", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="Dissimilarity control for chimeric filtering (default 1);")), ToolInput(tag="in_other", input_type=String(optional=True), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file;")), ToolOutput(tag="out_o_two", output_type=File(optional=True), selector=InputSelector(input_to_select="in_o_two", type_hint=File()), doc=OutputDocumentation(doc="Output file for R2;"))], container="quay.io/biocontainers/cd-hit-auxtools:4.8.1--hc9558a2_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Cd_Hit_Dup_V0_1_0().translate("wdl")

